thr = [0.0625 0.1563];
sigma = 2;

i = imread('shadow.bmp');
i0 = double(i);
i = i0(231:300, 161:320);
[gr,gc] = gradient(i);
g = sqrt(gr .^ 2 + gc .^ 2);

[gr4,gc4] = gradient(i, 4);
g4 = sqrt(gr4 .^ 2 + gc4 .^ 2);

figSize = 700 * [1 size(i, 1)/size(i, 2)];
figPos = [20, 60];
fig = 1;

putFig(fig, figPos, figSize)
bw(i);
savefig('canny9detail.tif');
fig = fig + 1;

putFig(fig, figPos, figSize)
bw(g)
saveFig('canny8magnitude1.tif');
fig = fig + 1;

putFig(fig, figPos, figSize)
bw(g4)
saveFig('canny8magnitude4.tif');
fig = fig + 1;

putFig(fig, figPos, figSize)
skip = 2;
r = size(gc, 1):-skip:1;
c = 1:skip:size(gc, 2);
m = length(r);
n = length(c);
x = 1:n;
y = 1:m;
h = quiver(x, y, gc(r, c), gr(r, c), '.');
axis image
axis off
set(h(1), 'LineWidth', 1.5)
saveFig('canny7phase.tif');
fig = fig + 1;

e = edge(i, 'canny', thr(1) / 2 * [0.99 1], 5);
putFig(fig, figPos, figSize)
bw(e);
saveFig('canny6sigma5.tif')
fig = fig + 1;

e = edge(i, 'canny', thr(1) / 2 * [0.99 1], 0.5);
putFig(fig, figPos, figSize)
bw(e);
saveFig('canny5sigma05.tif')
fig = fig + 1;

e = edge(i, 'canny', thr(2) * [0.99 1], 1);
putFig(fig, figPos, figSize)
bw(e);
saveFig('canny4sigmaHighThr.tif')
fig = fig + 1;

e = edge(i, 'canny', thr(1) * [0.99 1], 1);
putFig(fig, figPos, figSize)
bw(e);
saveFig('canny3sigmaLowThr.tif')
fig = fig + 1;

e = edge(i, 'canny', thr, 1);
putFig(fig, figPos, figSize)
bw(e);
saveFig('canny2sigmaHysteresis.tif')
fig = fig + 1;

figSize0 = 700 * [1 size(i0, 1)/size(i0, 2)];
e = edge(i0, 'canny', thr, 1);
putFig(fig, figPos, figSize0)
bw(e);
saveFig('canny1wholeS1.tif')
fig = fig + 1;

e = edge(i0, 'canny', thr, 8);
putFig(fig, figPos, figSize0)
bw(e);
saveFig('canny10wholeS8.tif')
fig = fig + 1;

% Stack the figures in reverse order
for f = (fig-1):(-1):1
    figure(f)
end